<id>
Persnonal Notepad for YaBB 2.4 (YaMMS Compatible Mod)
</id>

<version>
0.4
</version>

<mod info>
Description
-----------
Adds a Personal Notepad to the User CP

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.

Files to edit
-------------
Admin/ModList.pl 
Admin/NewSettings.pl 
Admin/Settings_Main.pl 
Languages/English/Admin.lng
Languages/English/Profile.lng
Sources/MyCenter.pl
Sources/Profile.pl
Sources/SubList.pl
Sources/System.pl

Version History
---------------
V0.1 - First release - 23rd November 2009
V0.2 - Added Spell Checking (if enabled) - 24th November 2009
V0.3 - Tidied up textarea - 25th November 2009
V0.4 - Added auto-focus if textarea is empty - 14th December 2009
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$mod_personalpad = "Personal Notepad|Derek Barnstorm|Adds a Personal Notepad to the User CP|0.4|14th December 2009";
	push (@installed_mods, "$mod_personalpad");
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$MaxSigLen = $MaxSigLen;				# Maximum Allowed Characters in Signatures
</search for>

<add before>
\$PersonalPadEnabled = $PersonalPadEnabled; 	# Enable Personal Notepad
\$MaxNotesLen = $MaxNotesLen;			# Maximum Allowed Characters in Personal Notepad
</add before>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
$ML_Allowed = 1 if $ML_Allowed eq '';
</search for>

<add after>
$MaxNotesLen = 2000 if $MaxNotesLen eq '';
</add after>

<search for>
			name => 'buddyListEnabled',
			validate => 'boolean',
		},
</search for>

<add after>
		{
			description => $admin_txt{'personalpad'},
			input_html => qq~<input type="checkbox" name="PersonalPadEnabled" value="1"${ischecked($PersonalPadEnabled)} />~,
			name => 'PersonalPadEnabled',
			validate => 'boolean',
		},
		{
			description => $admin_txt{'689b'},
			input_html => qq~<input type="text" name="MaxNotesLen" size="5" value="$MaxNotesLen" />~,
			name => 'MaxNotesLen',
			validate => 'number,null',
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'689a' => 'Maximum allowed characters in Away message',
</search for>

<add after>
'689b' => 'Maximum allowed characters in Personal Notepad',
</add after>

<search for>
'buddylist' => 'Enable Buddy List?',
</search for>

<add after>
'personalpad' => 'Enable Personal Notepad?',
</add after>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
'sid_expires_2' => 'seconds.',
</search for>

<add after>
'notepad' => 'Personal Notepad',
'savenotes' => 'Save Notes',
'maxnotes' => "Max $MaxNotesLen characters. Remaining characters: ",
</add after>

<search for>
1;
</search for>

<add before>
%spell_check = (
'chck_spell' => 'Check spelling',
'revert' => 'Revert to',
'close' => 'Close',
'rsm_edt' => 'Resume editing',
'no_error_found' => 'No spelling errors found',
'no_suggestions' => 'No suggestions found',
);

</add before>

<edit file>
Sources/MyCenter.pl
</edit file>

<search for>
		<span class="nav"><b><a href="$scripturl?$thisLink">$inmes_txt{'765'}</a></b></span>
		<br />
		~;
	}
</search for>

<add after>

    if ($PersonalPadEnabled) {
	    $thisLink = $profileLink . 'myprofileNotepad;username=' . $useraccount{$username} . $sidLink;
	    $MCProfMenu .= qq~
	    <span class="nav"><b><a href="$scripturl?$thisLink">$profile_txt{'notepad'}</a></b></span><br />~;
    }
</add after>

<search for>
		elsif ($action eq 'myprofileBuddy2') { &ModifyProfileBuddy2; }
</search for>

<add after>
		elsif ($action eq 'myprofileNotepad') { &ModifyProfileNotepad; }
		elsif ($action eq 'myprofileNotepad2') { &ModifyProfileNotepad2; }
</add after>
 
<edit file>
Sources/Profile.pl
</edit file>

<search for>
	@menucolors = qw(catbg catbg catbg catbg catbg catbg catbg);
</search for>

<replace>
	@menucolors = qw(catbg catbg catbg catbg catbg catbg catbg catbg);
</replace>

<search for>
if($buddyListEnabled) { $buttwht = "14%"; } else { $buttwht = "16%"; }
</search for>

<replace>
if($buddyListEnabled) { $buttwht = "12%"; } else { $buttwht = "14%"; }
</replace>

<search for>
		if($iamadmin) {
			$yymain .= qq~
			<td class="$menucolors[6]" valign="bottom" width='$buttwht' align="center"><span class="small"><b><a href="$scripturl?action=profileAdmin;username=$useraccount{$user};sid=$INFO{'sid'}">$profile_txt{820}</a></b></span></td>~;
		}
		if ($iamgmod && $allow_gmod_profile && $gmod_access2{"profileAdmin"} eq "on") {
			$yymain .= qq~
			<td class="$menucolors[6]" valign="bottom" width='$buttwht' align="center"><span class="small"><b><a href="$scripturl?action=profileAdmin;username=$useraccount{$user};sid=$INFO{'sid'}">$profile_txt{820}</a></b></span></td>~;
		}
</search for>

<replace>

        if ($PersonalPadEnabled) {
	        $yymain .= qq~
		    <td class="$menucolors[6]" valign="bottom" width='$buttwht' align="center"><span class="small"><b><a href="$scripturl?action=profileNotepad;username=$useraccount{$user};sid=$INFO{'sid'}">$profile_txt{notepad}</a></b></span></td>~;
		}
		
		if($iamadmin) {
			$yymain .= qq~
			<td class="$menucolors[7]" valign="bottom" width='$buttwht' align="center"><span class="small"><b><a href="$scripturl?action=profileAdmin;username=$useraccount{$user};sid=$INFO{'sid'}">$profile_txt{820}</a></b></span></td>~;
		}
		if ($iamgmod && $allow_gmod_profile && $gmod_access2{"profileAdmin"} eq "on") {
			$yymain .= qq~
			<td class="$menucolors[7]" valign="bottom" width='$buttwht' align="center"><span class="small"><b><a href="$scripturl?action=profileAdmin;username=$useraccount{$user};sid=$INFO{'sid'}">$profile_txt{820}</a></b></span></td>~;
		}
</replace>

<search for>
sub ModifyProfileAdmin {
	&is_admin_or_gmod;
	&PrepareProfile;

	my $user = $INFO{'username'};
	if (!${$uid.$user}{'password'}) { &LoadUser($user); }

	$menucolors[6] = "titlebg";
</search for>

<replace>
sub ModifyProfileNotepad {
	&SidCheck($action);
	&PrepareProfile;

	$menucolors[6] = "titlebg";

	my $scriptAction = qq~profileNotepad2~;
	if ($view) { 
		$scriptAction = qq~myprofileNotepad2~;
		$yytitle = qq~$profile_txt{'editmyprofile'} &rsaquo; $profile_txt{'notepad'}~;
		$profiletitle = qq~$profile_txt{'editmyprofile'} ($user) &rsaquo; $profile_txt{'notepad'}~;
		$yynavigation = qq~&rsaquo; <a href="$scripturl?action=mycenter" class="nav">$img_txt{'mycenter'}</a> &rsaquo; $profiletitle~;
	} else {
		$yytitle = qq~$profile_txt{'79'} &rsaquo; $profile_txt{'notepad'}~;
		$profiletitle = qq~$profile_txt{'79'} ($user) &rsaquo; $profile_txt{'notepad'}~;
		$yynavigation = qq~&rsaquo; $profiletitle~;
		&ProfileMenu;
	}
	
	$personalpad = ${$uid.$user}{'personalpad'};
	$personalpad =~ s~<br \/>~\n~g;
	
    # SpellChecker start
	if ($enable_spell_check) {
		$yyinlinestyle .= qq~<link href="$yyhtml_root/googiespell/googiespell.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="$yyhtml_root/AJS.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/googiespell.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/cookiesupport.js"></script>~;
		my $userdefaultlang = (split(/-/, $abbr_lang))[0];
		$userdefaultlang ||= 'en';
		$personalpad_spellcheck .= qq~
		GOOGIE_DEFAULT_LANG = '$userdefaultlang';
		var googie1 = new GoogieSpell("$yyhtml_root/googiespell/", "$boardurl/Sources/SpellChecker.pl?lang=");
		googie1.lang_chck_spell = '$spell_check{'chck_spell'}';
		googie1.lang_revert = '$spell_check{'revert'}';
		googie1.lang_close = '$spell_check{'close'}';
		googie1.lang_rsm_edt = '$spell_check{'rsm_edt'}';
		googie1.lang_no_error_found = '$spell_check{'no_error_found'}';
		googie1.lang_no_suggestions = '$spell_check{'no_suggestions'}';
		googie1.setSpellContainer("spell_container");
		googie1.decorateTextarea("personalpad");~;
		$personalpad_spelldiv = qq~<div style="width: 98%; padding-bottom: 3px; text-align: right;" id="spell_container"></div>~;
	}
	# SpellChecker end
	
	$showProfile .= qq~
<form action="$scripturl?action=$scriptAction;username=$useraccount{$INFO{'username'}};sid=$INFO{'sid'}" method="post" name="creator">
<table cellspacing="1" cellpadding="4" width="100%" align="center" class="bordercolor" border="0">
	<tr class="windowbg">
	    <td valign="middle" align="center">
	    $personalpad_spelldiv
	    <textarea cols="80" rows="15" style="width: 98%; padding: 3px;" name="personalpad" id="personalpad">$personalpad</textarea>
	    <br />
	    <span class="small">$profile_txt{'maxnotes'} <input value="$MaxNotesLen" size="3" name="msgCL" class="windowbg" style="border: 0px; width: 40px; padding: 1px; font-size: 11px;" readonly="readonly" /></span>
	    <script type="text/javascript" language="JavaScript">
		<!--
		    if (document.creator.personalpad.value == "") {
			    document.creator.personalpad.focus();
			}
		    var supportsKeys = false;
			function tick() {
				calcCharLeft(document.forms[0]);
				if (!supportsKeys) { timerID = setTimeout("tick()", 1500); }
			}
			function calcCharLeft(personalpad) {
				clipped = false;
				maxLength = $MaxNotesLen;
				if (document.creator.personalpad.value.length > maxLength) {
					document.creator.personalpad.value = document.creator.personalpad.value.substring(0,maxLength);
					charleft = 0;
					clipped = true;
				} else {
					charleft = maxLength - document.creator.personalpad.value.length;
				}
				document.creator.msgCL.value = charleft;
				return clipped;
			}
			tick();
			$personalpad_spellcheck
		// -->
		</script>
	</td>
	</tr>
	<tr class="catbg">
		<td height="50" valign="middle" align="center"><input type="submit" name="moda" value="$profile_txt{'savenotes'}" class="button" /><br /><span class="small">$profile_txt{'sid_expires_1'} $sid_expires $profile_txt{'sid_expires_2'}</span></td>
	</tr>
</table>
</form>~;

    if (!$view) {
		$yymain .= $showProfile;
		&template;
	}
}

sub ModifyProfileAdmin {
	&is_admin_or_gmod;
	&PrepareProfile;

	my $user = $INFO{'username'};
	if (!${$uid.$user}{'password'}) { &LoadUser($user); }

	$menucolors[7] = "titlebg";
</replace>

<search for>
	if ($PM_level == 1 || ($PM_level == 2 && ($iamadmin || $iamgmod || $iammod)) || ($PM_level == 3 && ($iamadmin || $iamgmod))) {
		$scriptAction = qq~profileIM~;
	}
	if ($buddyListEnabled) {
</search for>

<add before>
	if ($PersonalPadEnabled) {
		$scriptAction = qq~profileNotepad~;
	}
</add before>

<search for>
	${$uid.$user}{'buddylist'} = $member{'buddylist'};
	&UserAccount($user, "update");

	my $scriptAction;
	if ($iamadmin || ($iamgmod && $allow_gmod_profile && $gmod_access2{'profileAdmin'} eq 'on')) {
		$scriptAction = qq~profileAdmin~;
	} else {
		$scriptAction = qq~viewprofile~;
	}
</search for>

<add after>
	if ($PersonalPadEnabled) {
		$scriptAction = qq~profileNotepad~;
	}
</add after>

<search for>
	my $scriptAction = qq~viewprofile~;
	if ($iamadmin || ($iamgmod && $allow_gmod_profile && $gmod_access2{'profileAdmin'} eq 'on')) {
		$scriptAction = qq~profileAdmin~;
	}
	if ($view) { $scriptAction = qq~my$scriptAction~; }
	$yySetLocation = qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
	&redirectexit;
}
</search for>

<replace>
	my $scriptAction;
	if ($iamadmin || ($iamgmod && $allow_gmod_profile && $gmod_access2{'profileAdmin'} eq 'on')) {
		$scriptAction = qq~profileAdmin~;
	} else {
		$scriptAction = qq~viewprofile~;
	}
	if ($PersonalPadEnabled) {
		$scriptAction = qq~profileNotepad~;
	}
	if ($view) { $scriptAction = qq~my$scriptAction~; }
	$yySetLocation = qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
	&redirectexit;
}

sub ModifyProfileNotepad2 {
	&SidCheck($action);
	&PrepareProfile;

	my (%member, $key, $value);
	while (($key, $value) = each(%FORM)) {
		$value =~ s~\A\s+~~;
		$value =~ s~\s+\Z~~;
        $member{$key} = $value;
	}
	$member{'username'} = $user;

	&fatal_error("not_allowed") if $member{'moda'} ne $profile_txt{'savenotes'};
	
	&FromChars($member{'personalpad'});
	&ToHTML($member{'personalpad'});
	$member{'personalpad'} =~ s~[\n\r]{1,2}~<br />~g;
	$convertstr = $member{'personalpad'};
	$convertcut = $MaxNotesLen;
	&CountChars;
	$member{'personalpad'} = $convertstr;
	&ToChars($member{'personalpad'});
	${$uid.$user}{'personalpad'} = $member{'personalpad'};
	
    if ($extendedprofiles) { # run this before you start to save something!
		require "$sourcedir/ExtendedProfiles.pl";
		my $error = &ext_validate_submition($username,$user);
		if ($error ne "") { &fatal_error("extended_profiles_validation",$error); }
		&ext_saveprofile($user);
	}
	
	&UserAccount($user, "update");

	my $scriptAction = qq~viewprofile~;
	if ($iamadmin || ($iamgmod && $allow_gmod_profile && $gmod_access2{'profileAdmin'} eq 'on')) {
		$scriptAction = qq~profileAdmin~;
	}
	if ($view) { $scriptAction = qq~my$scriptAction~; }
	$yySetLocation = qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
	&redirectexit;
}
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'myprofileIM',"MyCenter.pl&mycenter",
'myprofileIM2',"MyCenter.pl&mycenter",
</search for>

<add after>
'myprofileNotepad',"MyCenter.pl&mycenter",
'myprofileNotepad2',"MyCenter.pl&mycenter",
</add after>

<search for>
'profileIM',"Profile.pl&ModifyProfileIM",
'profileIM2',"Profile.pl&ModifyProfileIM2",
</search for>

<add after>
'profileNotepad',"Profile.pl&ModifyProfileNotepad",
'profileNotepad2',"Profile.pl&ModifyProfileNotepad2",
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
	my @tags = qw(realname password position addgroups email hidemail regdate regtime regreason location bday gender userpic usertext signature template language stealth webtitle weburl icq aim yim skype myspace facebook msn gtalk timeselect timeformat timeoffset dsttimeoffset dynamic_clock postcount lastonline lastpost lastim im_ignorelist im_popup im_imspop pmmessprev pmviewMess pmactprev notify_me board_notifications thread_notifications favorites buddylist cathide pageindex reversetopic postlayout sesquest sesanswer session lastips onlinealert offlinestatus awaysubj awayreply awayreplysent spamcount spamtime);
</search for>

<add after>
	push(@tags, "personalpad");
</add after>